<?php

final class PhabricatorExtensionsSetupCheck extends PhabricatorSetupCheck {

  public function getDefaultGroup() {
    return self::GROUP_PHP;
  }

  public function isPreflightCheck() {
    return true;
  }

  protected function executeChecks() {
    // TODO: Make 'mbstring' a soft requirement.

    $required = array(
      'hash',
      'json',
      'openssl',
      'mbstring',
      'ctype',
      'mysqli',

      // There is a tiny chance we might not need this, but a significant
      // number of applications require it and it's widely available.
      'curl',
    );

    $need = array();
    foreach ($required as $extension) {
      if (!extension_loaded($extension)) {
        $need[] = $extension;
      }
    }

    if (!$need) {
      return;
    }

    $message = pht('Required PHP extensions are not installed.');

    $issue = $this->newIssue('php.extensions')
      ->setIsFatal(true)
      ->setName(pht('Missing Required Extensions'))
      ->setMessage($message);

    foreach ($need as $extension) {
      $issue->addPHPExtension($extension);
    }
  }
}
